local ScriptLoaded = false

freeslot("MT_MINICREWMATE", "S_MINICREWMATE_STAND", "S_MINICREWMATE_RUN1", "S_MINICREWMATE_RUN2", "S_MINICREWMATE_RUN3", "S_MINICREWMATE_RUN4")

local senderp
local sender

local function LookForPlayer(mo)  //Old P_LookForEnemis
	local lastplayer
	local dist
	local lastdist = 0

	for player in players.iterate()
		if player == sender // 'Ignore us' check
			continue
		end
		
		if (player.playerstate != PST_LIVE) // I'm Dead.
			continue
		end

		// Can't get it if you can't see it!
		if not P_CheckSight(mo,player.mo)
			continue
		end

		dist = P_AproxDistance(P_AproxDistance(mo.x - player.mo.x, mo.y - player.mo.y), mo.z - player.mo.z)
		if (lastmo and (dist > lastdist)) // Last one is closer to you?
			continue
		end
		
		local long = R_PointToDist2(mo.x, mo.y, player.mo.x, player.mo.y)
		local longz = R_PointToDist(mo.z, player.mo.z)
		if long > 1000*FRACUNIT
		and (longz > 300*FRACUNIT or longz < -300*FRACUNIT)
			continue
		end	

		// Found a target
		lastplayer = player.mo
		lastdist = dist
	end
	return lastplayer
end

local function LookForEnemy(mo)  //Old P_LookForEnemis
	local lastenemy
	local dist
	local lastdist = 0

	for enemy in mobjs.iterate()
		if enemy == mo // 'Ignore us' check
			continue
		end
		
		if (enemy.health <= 0) // I'm Dead.
			continue
		end

		// Can't get it if you can't see it!
		if not P_CheckSight(mo,enemy)
			continue
		end
		
		if not ((enemy.flags & MF_ENEMY)
		or (enemy.flags & MF_BOSS))
			continue
		end

		dist = P_AproxDistance(P_AproxDistance(mo.x - enemy.x, mo.y - enemy.y), mo.z - enemy.z)
		if (lastmo and (dist > lastdist)) // Last one is closer to you?
			continue
		end
		
		local long = R_PointToDist2(mo.x, mo.y, enemy.x, enemy.y)
		local longz = R_PointToDist(mo.z, enemy.z)
		if long > 1000*FRACUNIT
		and (longz > 300*FRACUNIT or longz < -300*FRACUNIT)
			continue
		end	

		lastenemy = enemy
		lastdist = dist
	end
	return lastenemy
end

addHook("ThinkFrame", function()
	if not(ScriptLoaded)
		and CBW_Battle 
		then
		ScriptLoaded = true 
		local B = CBW_Battle 
				
		B.Action.Mini=function(mo,doaction)

			local player = mo.player
			
			player.actiontext = "Mini Crewmate Spawn" 
			player.actionrings = 10
			player.action2text = nil
			player.action2rings = 0 
			
			if not(B.CanDoAction(player)) 
				player.actionstate = 0 
				return end	
	
			if player.actionstate == 0 
				if doaction == 1 
					player.actionstate = 1 
					player.actiontime = 0 
					B.PayRings(player) 
					S_StartSound(mo,sfx_s3k3c)
					
				end
			end
			
			if player.actionstate == 1 
				player.actiontime = $+1
				
				P_SetObjectMomZ(player.mo, 5*FRACUNIT)
				P_InstaThrust(player.mo, player.mo.angle, - 5*FRACUNIT)
				player.mo.state = S_PLAY_VENT
				
				if player.actiontime == 2 then 
					player.actionstate = 2
					player.actiontime = 0
				end
			end
			
			if player.actionstate == 2 
				player.actiontime = $+1
				
				
				player.mo.state = S_PLAY_EDGE
				local gotox = player.mo.x+FixedMul(150*FRACUNIT, cos(player.mo.angle))
				local gotoy = player.mo.y+FixedMul(150*FRACUNIT, sin(player.mo.angle))
				local gotoz = player.mo.z+FixedMul(150*FRACUNIT, cos(player.aiming))
				local mini = P_SpawnMobj(gotox, gotoy, gotoz, MT_MINICREWMATE)
				mini.spriteyscale = FRACUNIT/15
				mini.spritexscale = FRACUNIT/15
				mini.color = player.mo.color
				mini.fuse = 150
				senderp = player
				sender = player.mo
				B.ApplyCooldown(player,TICRATE*2)
				
				if player.actiontime == 1
					player.actionstate = 0
				end
			end
			
		end
		
		/*local PriorityFunc = function(player)
			if player.actionstate == 2 then
				B.SetPriority(player,3,1,nil,3,1,"mini crewmate")
			end
		end*/
		
		CBW_Battle.SkinVars["impostor"] = {
			special = B.Action.Mini
		}
	end
end)

addHook("MobjThinker", function(mo)
	mo.target2 = LookForPlayer(mo)
	if mo.valid
	and not (mo.flags2 & MF2_DONTDRAW)
			if mo.target2
				mo.target = LookForPlayer(mo)
			else
				mo.target = LookForEnemy(mo)
			end	
			if not mo.target
				if mo.state != S_MINICREWMATE_STAND
					mo.state = S_MINICREWMATE_STAND
				end
			end
			if mo.target and mo.target != sender //or mo.target != senderp
				local targetang = R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y)
				local dist = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
				if P_IsObjectOnGround(mo)
					P_InstaThrust(mo, targetang, 10*FRACUNIT)
					if (mo.state == S_MINICREWMATE_STAND)
						mo.state = S_MINICREWMATE_RUN1
					end
					if mo.target.z > mo.z
						mo.momz = 7*FRACUNIT
					end	
				end
				mo.angle = targetang
				if dist < 100*FRACUNIT
					CBW_Battle.SetPriority(senderp,3,1,nil,3,1,"mini crewmate")
					P_DamageMobj(mo.target, mo, mo)
					local die = P_SpawnGhostMobj(mo)
					die.fuse = 15
					die.color = mo.color
					die.colorized = true
					die.spriteyscale = FRACUNIT/15
					die.spritexscale = FRACUNIT/15
					mo.flags2 = $|MF2_DONTDRAW
					P_DamageMobj(mo, mo, mo, DMG_INSTAKILL)
				end
			end	
	end	
end, MT_MINICREWMATE)